﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BeegraffCorp.BLL
{
    /// <summary>
    ///     Interface that should be inherited by all entities manager
    /// </summary>
    /// <typeparam name="T">The entity's type</typeparam>
    public interface IEntitiesManager<T>
    {
        /// <summary>
        ///     Gets all entities
        /// </summary>
        /// <returns></returns>
        List<T> SelectAll();

        /// <summary>
        ///     Saves the entity
        /// </summary>
        /// <param name="entity"></param>
        void Save(T entity);

        /// <summary>
        ///     Deletes the entity
        /// </summary>
        /// <param name="entity"></param>
        void Delete(T entity);
    }
}
