﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BeegraffCorp.Data
{
    /// <summary>
    ///     Represents an employee of Beegraff Corporation
    /// </summary>
    [Serializable]
    public class Employee
    {
        /// <summary>
        ///     Gets or sets the employee's id
        /// </summary>
        public int EmployeeId { get; set; }

        /// <summary>
        ///     Gets or sets the name
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        ///     Gets or sets the firstname
        /// </summary>
        public string FirstName { get; set; }

        /// <summary>
        ///     Gets or sets the birthdate
        /// </summary>
        public DateTime Birthdate { get; set; }

        /// <summary>
        ///     Gets or sets a flag that indicates if the Employee is a manager
        /// </summary>
        public bool IsManager { get; set; }

        /// <summary>
        ///     Gets or sets the employee's manager id
        /// </summary>
        public int? ManagerId { get; set; }

        /// <summary>
        ///     Gets or sets the department id of the employee
        /// </summary>
        public int? DepartmentId { get; set; }

        public override string ToString()
        {
            return String.Format("{0} {1}", FirstName, Name);
        }
    }
}
