﻿using BeegraffCorp.BLL;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using BeegraffCorp.Data;
using System.Linq;

namespace BeegraffCorp.Tests
{
    
    
    /// <summary>
    ///This is a test class for DepartmentsManagerTest and is intended
    ///to contain all DepartmentsManagerTest Unit Tests
    ///</summary>
    [TestClass()]
    public class DepartmentsManagerTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Delete
        ///</summary>
        [TestMethod()]
        public void DeleteTest()
        {
            string dataFile = "departments.xml"; // TODO: Initialize to an appropriate value
            DepartmentsManager target = new DepartmentsManager(dataFile); // TODO: Initialize to an appropriate value

            var departments = target.SelectAll();

            if (departments.Any())
            {
                Department toDelete = departments.FirstOrDefault(d => d.Name == "Development");
                Assert.IsNotNull(toDelete);

                target.Delete(toDelete);

                departments = target.SelectAll();

                var department = departments.FirstOrDefault(d => d.Name == "Development");
                Assert.IsNull(department);
            }
            else
            {
                Assert.Fail("No available department to delete");
            }
        }

        /// <summary>
        ///A test for Save
        ///</summary>
        [TestMethod()]
        public void SaveTest()
        {
            string dataFile = "departments.xml"; // TODO: Initialize to an appropriate value
            DepartmentsManager target = new DepartmentsManager(dataFile); // TODO: Initialize to an appropriate value
            Department entity = new Department { Id = -1, Name = "Development" };
            target.Save(entity);

            var departments = target.SelectAll();
            if (departments.Any())
            {
                var insertedDepartment = departments.FirstOrDefault(d => d.Name == "Development");
                Assert.IsNotNull(insertedDepartment);
            }
            else
            {
                Assert.Fail("No department was inserted");
            }
        }
    }
}
