﻿using BeegraffCorp.BLL;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using BeegraffCorp.Data;
using System.Linq;

namespace BeegraffCorp.Tests
{
    
    
    /// <summary>
    ///This is a test class for EmployeesManagerTest and is intended
    ///to contain all EmployeesManagerTest Unit Tests
    ///</summary>
    [TestClass()]
    public class EmployeesManagerTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Delete
        ///</summary>
        [TestMethod()]
        public void DeleteTest()
        {
            string dataFile = "employees.xml"; // TODO: Initialize to an appropriate value
            EmployeesManager target = new EmployeesManager(dataFile); // TODO: Initialize to an appropriate value

            var employees = target.SelectAll();

            if (employees.Any())
            {
                Employee toDelete = employees.FirstOrDefault(d => d.Name == "Corioland" && d.FirstName == "Julien");
                Assert.IsNotNull(toDelete);

                target.Delete(toDelete);

                employees = target.SelectAll();

                var employee = employees.FirstOrDefault(d => d.Name == "Corioland" && d.FirstName == "Julien");
                Assert.IsNull(employee);
            }
            else
            {
                Assert.Fail("No available employee to delete");
            }
        }

        /// <summary>
        ///A test for Save
        ///</summary>
        [TestMethod()]
        public void SaveTest()
        {
            string dataFile = "employees.xml"; // TODO: Initialize to an appropriate value
            EmployeesManager target = new EmployeesManager(dataFile); // TODO: Initialize to an appropriate value
            Employee entity = new Employee { EmployeeId = -1, Name = "Corioland", FirstName = "Julien" };
            target.Save(entity);

            var employees = target.SelectAll();
            if (employees.Any())
            {
                var insertedEmployee = employees.FirstOrDefault(d => d.Name == "Corioland" && d.FirstName == "Julien");
                Assert.IsNotNull(insertedEmployee);
            }
            else
            {
                Assert.Fail("No employee was inserted");
            }
        }
    }
}
